package net.knarcraft.paidsigns.command;

import net.knarcraft.paidsigns.utility.Tokenizer;
import org.bukkit.command.Command;
import org.bukkit.command.CommandSender;
import org.bukkit.command.TabCompleter;
import org.jetbrains.annotations.NotNull;
import org.jetbrains.annotations.Nullable;

import java.util.ArrayList;
import java.util.List;

/**
 * The tab completer for the add paid sign command
 */
public class AddTabCompleter implements TabCompleter {

    private static List<String> ids;
    private static List<String> lines;
    private static List<String> costs;
    private static List<String> options;

    @Nullable
    @Override
    public List<String> onTabComplete(@NotNull CommandSender sender, @NotNull Command command, @NotNull String alias,
                                      @NotNull String[] args) {
        if (ids == null) {
            initializeValues();
        }
        List<String> arguments = Tokenizer.tokenize(String.join(" ", args));

        if (arguments.size() < 1) {
            return ids;
        } else if (arguments.size() < 2) {
            return lines;
        } else if (arguments.size() < 3) {
            return costs;
        } else if (arguments.size() < 5) {
            return options;
        }
        return new ArrayList<>();
    }

    /**
     * Initializes the values available for tab completion
     */
    private static void initializeValues() {
        ids = new ArrayList<>();
        ids.add("[Gate]");
        ids.add("\"[Lift Up]\"");
        ids.add("\"[Lift Down]\"");

        lines = new ArrayList<>();
        lines.add("1");
        lines.add("2");
        lines.add("3");
        lines.add("4");

        costs = new ArrayList<>();
        costs.add("1");
        costs.add("5");
        costs.add("10");
        costs.add("15");

        options = new ArrayList<>();
        options.add("default");
        options.add("true");
        options.add("false");
    }

}
